#ifndef _DYNAMICS_H_
#define _DYNAMICS_H_

#include <mpc/types.h>
#include <functional>

namespace MPC {

        static CostFunction cost;
        static CostFunctionD costd;
        static Dynamics dyn;
        static DynamicsD dynd;

        bool setDynamicFunction(Dynamics f, DynamicsD fd);
        bool setCostFunction(CostFunction f, CostFunctionD fd);

        float dynamicsAndCost(const VectorT &x, const VectorT &u);
        void dynamicsAndCost(const VectorT &x, const VectorT &u, VectorT &xNew, float &cNew);
        void dynamicsAndCost(const VectorT &x, const VectorT &u, MatrixT::ColXpr xNew, float &cNew);
        void dynamicsAndCost(Trajectory &t);
        void dynamicsAndCostDerivative(Trajectory &t, TrajectoryDeriv &d);
}

#endif
