#ifndef _EXAMPLES_EUCLIDEAN_H_
#define _EXAMPLES_EUCLIDEAN_H_

#include <mpc/types.h>

using namespace MPC;

namespace euclidean {
        typedef std::vector<VectorT> EuclideanObstacles;

        void setGoal(const VectorT &g);
        void setObstacles(const EuclideanObstacles &obs);
        EuclideanObstacles &getObstacles();

        void dynamics(const VectorT &x, const VectorT &u, VectorT &xNext);
        void dynamicsD(const VectorT &x, const VectorT &u, Deriv &d);
        float cost(const VectorT &x, const VectorT &u);
        void costD(const VectorT &x, const VectorT &u, Deriv &d);
}


#endif
