#ifndef _MPC_H_
#define _MPC_H_

#include <mpc/types.h>
#include <mpc/dynamics.h>

#include <functional>

namespace MPC {

        // NOTE: both functions should return an int notifying whether the execution diverged (see diverge parameter in ddp)
        int forwardPass(const VectorT &x0, const MatrixT &u, const LocalValueFunction &v, const Trajectory &in, Trajectory &out, float alpha);
        int backwardPass(const TrajectoryDeriv &d, LocalValueFunction &v, float lam);

        // NOTE: this function will be used to setup dynamics and cost function pointers 
        bool DDP_init(Dynamics dyn, DynamicsD dynd, CostFunction cost, CostFunctionD costd);

        // DDP will fill a newly optimized trajectory into t 
        void DDP(const VectorT &x0, const MatrixT &u0, const DDPParams &params, const int maxIter, Trajectory &t);
}
#endif
